package gen

import (
	. "git.eugeniocarvalho.dev/eugeniucarvalho/apicodegen/common"
)

var ServiceTemplate = `
[Unit]
Description=Gojus
Documentation=https://gojus.com.br
After=network-online.target
Wants=network-online.target systemd-networkd-wait-online.service
[Service]
#Restart=on-failure
#StartLimitInterval=86400
#StartLimitBurst=5
; User and group the process will run as.
#User=www-data
#Group=www-data
User=root
Group=root
; Letsencrypt-issued certificates will be written to this directory.
;Environment="GOOGLE_APPLICATION_CREDENTIALS=/apps/sys/gojus/ky.json" GOOGLE_CLOUD_PROJECT=173520589311
; Always set "-root" to something safe in case it gets forgotten in the Caddyfile.
ExecStart=/apps/sys/gojus/main -config=/apps/sys/gojus/config.production.json
ExecReload=/bin/kill -USR1 $MAINPID
#RootDirectory=/apps/sys/gojus
WorkingDirectory=/apps/sys/gojus
; Limit the number of file descriptors; see "man systemd.exec" for more limit settings.
LimitNOFILE=1048576
; Unmodified caddy is not expected to use more than that.
LimitNPROC=64
; Use private /tmp and /var/tmp, which are discarded after caddy stops.
PrivateTmp=true
; Use a minimal /dev
PrivateDevices=true
; Hide /home, /root, and /run/user. Nobody will steal your SSH-keys.
ProtectHome=true
; Make /usr, /boot, /etc and possibly some more folders read-only.
ProtectSystem=full
; … except /etc/ssl/caddy, because we want Letsencrypt-certificates there.
;   This merely retains r/w access rights, it does not add any new. Must still be writable on the host!
ReadWriteDirectories=/apps/sys/gojus
; The following additional security directives only work with systemd v229 or later.
; They further retrict privileges that can be gained by caddy. Uncomment if you like.
; Note that you may have to add capabilities required by any plugins in use.
;CapabilityBoundingSet=CAP_NET_BIND_SERVICE
AmbientCapabilities=CAP_NET_BIND_SERVICE
;NoNewPrivileges=true
[Install]
WantedBy=multi-user.target
`

func CreateServiceFile(project *Project) {

}
